#include <stdio.h>

#include "map.hh"
#include "trace.hh"
#include "redirect.hh"
#include "loadmap.hh"
#include "matrix.hh"
#include "xyz.hh"

int main(void)
{
    fflush(stdout);
    
    RedirectOut(1, "loadmap.log");
    
    Map *test = LoadMap("./testmap.so");
    fflush(stdout);
    
    Unredirect(1);
    
    for(int y=0; y<720; y+=2)
    {
        char Buf[64];
        sprintf(Buf, "diu%03d.tga", y/2);
        
        int zy = y;
        if(zy >= 360)zy = 360*2-zy;

        Trace(640,480,
              XYZ(250+zy/5.0,
                  330-zy/5.0,
                  190-zy/5.0),
              Matrix(DEG2RAD(90+30), DEG2RAD(y), DEG2RAD(0+5)),
              test,
              Buf);
        printf("Wrote %s\n", Buf);
    break;
    }
    
    delete test;
    
    return 0;
}
