#ifndef bqtObjectHH
#define bqtObjectHH

#include "xyz.hh"
#include "rgb.hh"

class Object;
struct HitRec
{
    XYZ point;
    XYZ normal;
    bool washit;
    Pigment Pigm;
    Object *obj;
    FLOAT ior;
public:
    HitRec() : point(), normal(),
               washit(false), Pigm(),
               obj(NULL), ior(1.0)
    {
    }
};

class Object
{
public:
    virtual ~Object();
    
    /* See if a ray hits it. */
    virtual void TryHit(HitRec &res, const XYZ &eye, const XYZ &dir) const = 0;
    
    /* Bounding box */
    virtual const XYZ Min() const = 0;
    virtual const XYZ Max() const = 0;
};

#endif

/*
Initial D: Street racingia rirajoilla. Pojat hurjastelee autoilla ja haikailee tyttjen pern.
Slam Dunk: Vhn sama kuin Initial D, mutta koripallosta autojen sijaan.
Inu Yasha: Japanilaista mystiikkaa nykyajan ja menneisyyden rajamailla.
Gundam Wing: Ehk lnsimaisin kaikista. Megarobotteja ja taisteluja. Poikia ja tyttj.
Vandread: Animemaisempi kuin Gundam Wing, hieman pervompi ja enemmn huumoria.
Jubei Chan: Samuraitarina, jossa on harvinaisen paljon pikkutyttihin vetoavaa animekikkailua.
*/
